import { assert, test, vi } from 'vitest';
import { ObjectPreviewUtil } from "../js/ObjectPreviewUtil";

const schemaSchema = {
    type: "object",
    title: "Schema",
    required: [
        "name",
        "schema",
        "identifier"
    ],
    properties: {
        identifier: {
            type: "string",
            cordra: {
                type: {
                    autoGeneratedField: "handle"
                }
            }
        },
        name: {
            type: "string",
            title: "Name",
            minLength: 1,
            cordra: {
                preview: {
                    showInPreview: true,
                    isPrimary: true
                }
            }
        },
        baseUri: {
            type: "string"
        },
        description: {
            type: "string",
            format: "textarea",
            title: "Description",
            cordra: {
                preview: {
                    showInPreview: true,
                    excludeTitle: true
                }
            }
        },
        schema: {
            type: "object",
            format: "json",
            title: "Schema"
        },
        javascriptIsModule: {
            type: "boolean"
        },
        javascript: {
            type: "string",
            format: "javascript",
            title: "JavaScript"
        },
        hashObject: {
            type: "boolean"
        },
        indexObjects: {
            type: "boolean"
        },
        indexPayloads: {
            type: "boolean"
        },
        authConfig: {
            type: [
                "object",
                "null"
            ],
            format: "json",
            description: "Enter explicit null to delete"
        }
    }
};
const AppMock = {
    getSchema: vi.fn(() => schemaSchema)
};
vi.stubGlobal('APP', AppMock);

test('getPreviewData', () => {
    const schemaCordraObject = {
        id: "test/e5e6ba5bdf35203ed2c2",
        type: "Schema",
        content: {
            identifier: "test/e5e6ba5bdf35203ed2c2",
            name: "Document",
            schema: {
                type: "object",
                title: "Document",
                required: [
                    "id",
                    "name"
                ],
                properties: {
                    id: {
                        type: "string",
                        cordra: {
                            type: {
                                autoGeneratedField: "handle"
                            }
                        }
                    },
                    name: {
                        type: "string",
                        title: "Name",
                        cordra: {
                            preview: {
                                showInPreview: true,
                                isPrimary: true
                            }
                        }
                    },
                    description: {
                        type: "string",
                        format: "textarea",
                        title: "Description",
                        cordra: {
                            preview: {
                                showInPreview: true
                            }
                        }
                    },
                    creationDate: {
                        type: "string",
                        title: "Creation Date",
                        cordra: {
                            type: {
                                autoGeneratedField: "creationDate"
                            }
                        }
                    },
                    modificationDate: {
                        type: "string",
                        title: "Modification Date",
                        cordra: {
                            type: {
                                autoGeneratedField: "modificationDate"
                            }
                        }
                    },
                    createdBy: {
                        type: "string",
                        title: "Created By",
                        cordra: {
                            type: {
                                autoGeneratedField: "createdBy"
                            }
                        }
                    },
                    modifiedBy: {
                        type: "string",
                        title: "Modified By",
                        cordra: {
                            type: {
                                autoGeneratedField: "modifiedBy"
                            }
                        }
                    }
                }
            },
            javascript: ""
        },
        metadata: {
            createdOn: 1665585599620,
            createdBy: "admin",
            modifiedOn: 1666187518324,
            modifiedBy: "admin",
            txnId: 1666187518301005
        }
    };

    const previewData = ObjectPreviewUtil.getPreviewData(schemaCordraObject);
    assert.exists(previewData);
    const nameData = previewData['/name'];
    assert.exists(nameData);
    assert.equal(nameData.previewJson, 'Document');
    assert.equal(nameData.title, 'Name');
    assert.isTrue(nameData.isPrimary);
    assert.isTrue(nameData.showInPreview);
});
